﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Yulin.YWinForm
{
    public class ListViewSorter
    {
        private ListView ListView { get; set; }
        private bool ShiftKeyDown { get; set; }


        /// <summary>
        /// 暂不支持动态增删列、更改列标头文本！！！独占了 ListView 的列的 Tag 属性！！！
        /// </summary>
        /// <param name="listView"></param>
        public ListViewSorter(ListView listView)
        {
            ListView = listView;
            for (int i = 0; i < ListView.Columns.Count; i++)
            {
                ListView.Columns[i].Tag = new ListViewSortColumn(ListView.Columns[i]);
            }

            listView.KeyDown += new KeyEventHandler(delegate(object sender, KeyEventArgs e)
            {
                if (e.Shift)
                {
                    ShiftKeyDown = true;
                }
            });

            listView.KeyUp += new KeyEventHandler(delegate(object sender, KeyEventArgs e)
            {
                if (!e.Shift)
                {
                    ShiftKeyDown = false;
                }
            });

            ListView.ColumnClick += new ColumnClickEventHandler(delegate(object sender, ColumnClickEventArgs e)
            {
                Sort(e.Column);
            });
        }


        public void SetSortDataType(int column, ListViewSortDataType listViewSortDataType)
        {
            (ListView.Columns[column].Tag as ListViewSortColumn).SortDataType = listViewSortDataType;
        }


        ///// <summary>
        ///// 开启支持排序的列。
        ///// </summary>
        ///// <param name="enabledColumns"></param>
        //public void EnableSort(int[] enabledColumns)
        //{
        //    for (int i = 0; i < enabledColumns.Length; i++)
        //    {
        //        ListViewSortColumn sc = (ListView.Columns[enabledColumns[i]].Tag as ListViewSortColumn);
        //        sc.SortEnabled = true;
        //    }
        //}


        private void Sort(int column)
        {
            ListViewSortColumn sc = (ListView.Columns[column].Tag as ListViewSortColumn);
            if (!sc.SortEnabled)
            {
                return;
            }

            if (!ShiftKeyDown)
            {
                CancelSortExcept(column);
            }
            ReverseSort(column, SortOrder.Ascending);

            ListView.ListViewItemSorter = new ListViewItemSorter(ListView);
            ListView.Sort();
        }


        private void CancelSortExcept(int column)
        {
            for (int i = 0; i < ListView.Columns.Count; i++)
            {
                if (i != column)
                {
                    ListViewSortColumn sc = (ListView.Columns[i].Tag as ListViewSortColumn);
                    sc.CancelSort();
                }
            }
        }


        private void ReverseSort(int column, SortOrder defaultSortOrder)
        {
            ListViewSortColumn sc = (ListView.Columns[column].Tag as ListViewSortColumn);
            sc.ReverseSort(defaultSortOrder);
        }
    }
}
